#!/bin/sh
set -e

FAIL=0
DIR=$(readlink -f $(dirname $0))
if [ "$1" = "-q" ]; then
	export MSGLEVEL=2
elif [ "$1" = "-v" ]; then
	export MSGLEVEL=4
fi

if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null; then
	CTEST='\033[1;32m'
	CHIGH='\033[1;35m'
	CRESET='\033[0m'
elif [ -z "${MSGLEVEL}" ]; then
	export MSGLEVEL=2
fi

if [ -z "$MSGLEVEL" ]; then
	MSGLEVEL=5
fi

for testcase in $(run-parts --list $DIR | grep '/test-'); do
	if [ "$MSGLEVEL" -le 2 ]; then
		echo -n "${CTEST}Testcase ${CHIGH}$(basename ${testcase})${CRESET}: "
	else
		echo "${CTEST}Run Testcase ${CHIGH}$(basename ${testcase})${CRESET}"
	fi
	if ! ${testcase}; then
                 FAIL=$((FAIL+1))
                 echo "$(basename $testcase) ... FAIL"
        fi
	if [ "$MSGLEVEL" -le 2 ]; then
		echo
	fi
done

echo "failures: $FAIL"
exit $FAIL
